/* Setup */

USE AdventureWorks
GO
CREATE TABLE ExceptionT1
(
a int NOT NULL PRIMARY KEY
)
CREATE TABLE ExceptionT2
(
a int NOT NULL REFERENCES ExceptionT1(a)
)
GO
INSERT INTO ExceptionT1 VALUES (1)
INSERT INTO ExceptionT1 VALUES (3)
INSERT INTO ExceptionT1 VALUES (4)
INSERT INTO ExceptionT1 VALUES (6)
GO

/* Step 1 */
SET XACT_ABORT OFF
BEGIN TRAN
INSERT INTO ExceptionT2 VALUES (1)
INSERT INTO ExceptionT2 VALUES (2) /* Foreign Key Error */
INSERT INTO ExceptionT2 VALUES (3)
COMMIT TRAN
GO

/* Step 2 */
SELECT *
FROM ExceptionT1
GO
SELECT *
FROM ExceptionT2
GO

/* Step 3 */

SET XACT_ABORT OFF
BEGIN TRY
BEGIN TRAN
INSERT INTO ExceptionT2 VALUES (4)
INSERT INTO ExceptionT2 VALUES (5) /* Foreign Key Error */
INSERT INTO ExceptionT2 VALUES (6)
COMMIT TRAN
PRINT 'Transaction committed'
END TRY
BEGIN CATCH
ROLLBACK
PRINT 'Transaction rolled back'
END CATCH
GO

/* Step 4 */
SELECT *
FROM ExceptionT1
GO
SELECT *
FROM ExceptionT2
GO

/* Cleanup */

DROP TABLE ExceptionT2
DROP TABLE ExceptionT1
GO

